hdu 2612 Find a way(BFS)

2024-02-21 00:48
文章标签 bfs find hdu 2612 way

本文主要是介绍hdu 2612 Find a way(BFS),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

原题链接:

http://acm.hdu.edu.cn/showproblem.php?pid=2612



题目大意:

Y与M到任意一个'@'所需最少时间。


思路:

两遍BFS计算出Y到任意一个’@‘的所需时间以及M到任意一个’@‘的所需时间,求和的最小值。


哎,挺简单的就是不知道最初写的哪有bug。

求bug。。T.T


正确代码如下:

#include<iostream>
#include<cstdio>
#include<cstring>
#include<queue>
#include<utility>
using namespace std;
const int MAXN=200+10;bool flag[MAXN][MAXN];
int sss[MAXN][MAXN][2];//两遍BFS的结果
char G[MAXN][MAXN];
int n,m;const int dir[][2]={{-1,0},{0,-1},{1,0},{0,1}};
bool check(int x,int y)
{if(x>=0&&x<n&&y>=0&&y<m&&G[x][y]!='#'&&!flag[x][y])return true;return false;
}struct node
{int x,y;int ss;
};void BFS(int x,int y,int s)
{memset(flag,0,sizeof(flag));flag[x][y]=true;queue<node>q;node pos,nextpos;pos.x=x;pos.y=y;pos.ss=0;q.push(pos);while(!q.empty()){pos=q.front();q.pop();nextpos.ss=pos.ss+1;for(int i=0;i<4;i++){int tx=pos.x+dir[i][0];int ty=pos.y+dir[i][1];if(check(tx,ty)){nextpos.x=tx;nextpos.y=ty;flag[tx][ty]=true;if(G[tx][ty]=='@')sss[tx][ty][s]=nextpos.ss;q.push(nextpos);}}}
}
int main()
{while(scanf("%d%d",&n,&m)!=EOF){//memset(ss,0,sizeof(ss));//不知为何不能初始化为0for(int i=0;i<n;i++)for(int j=0;j<m;j++)sss[i][j][0]=sss[i][j][1]=1e5;for(int i=0;i<n;i++)scanf("%s",G[i]);for(int i=0;i<n;i++)for(int j=0;j<m;j++){if(G[i][j]=='Y')BFS(i,j,0);else if(G[i][j]=='M')BFS(i,j,1);}int ans=1e5;for(int i=0;i<n;i++)for(int j=0;j<m;j++)if(G[i][j]=='@'&&ans>sss[i][j][0]+sss[i][j][1])ans=sss[i][j][0]+sss[i][j][1];printf("%d\n",ans*11);}return 0;
}


错误的代码:

#include<iostream>
#include<cstdio>
#include<cstring>
#include<queue>
#include<utility>
#include<map>
using namespace std;
const int MAXN=200+10;
char G[MAXN][MAXN];
bool flog[MAXN][MAXN];
int num;
int n,m;
typedef pair<int,int>ii;
const int nextpos[][2]={{1,0},{-1,0},{0,-1},{0,1}};map<int,int>kfc;bool check(int x,int y)
{if(x<0||x>=n||y<0||y>=m||G[x][y]=='#'||flog[x][y])return false;return true;
}void BFS(int x,int y)
{memset(flog,0,sizeof(flog));flog[x][y]=true;queue<ii>q;ii pos;pos.first=x*n+y;pos.second=0;q.push(pos);int s=0;while(!q.empty()){pos=q.front();q.pop();if(G[pos.first/n][pos.first%n]=='@'){kfc[pos.first]+=pos.second;s++;if(s==num)return;}for(int i=0;i<4;i++){int tempx=pos.first/n+nextpos[i][0];int tempy=pos.first%n+nextpos[i][1];if(check(tempx,tempy)){ii p;p.first=tempx*n+tempy;p.second=pos.second+1;flog[tempx][tempy]=true;q.push(p);}}}
}
int main()
{while(scanf("%d%d",&n,&m)!=EOF){num=0;kfc.clear();int x1,y1,x2,y2;for(int i=0;i<n;i++){scanf("%s",G[i]);}for(int i=0;i<n;i++){for(int j=0;j<m;j++){if(G[i][j]=='@'){kfc[i*n+j]=0;num++;}else if(G[i][j]=='Y'){x1=i;y1=j;}else if(G[i][j]=='M'){x2=i;y2=j;}}}BFS(x1,y1);BFS(x2,y2);int ans=1e5;for(map<int,int>::iterator it=kfc.begin();it!=kfc.end();it++){if(it->second<ans&&it->second!=0) ans=it->second;//cout<<it->second<<endl;}cout<<ans*11<<endl;}return 0;
}

#include<iostream>
#include<cstdio>
#include<cstring>
#include<queue>
using namespace std;
const int MAXN=200+10;
bool flog[MAXN][MAXN];
int step[MAXN][MAXN][2];
char G[MAXN][MAXN];
int n,m;
const int dir[][2]={{-1,0},{0,-1},{1,0},{0,1}};
bool check(int x,int y)
{if(x<0||x>=n|y<0||y>=m||G[x][y]=='#'||flog[x][y])return false;return true;
}
void BFS(int x,int y,int s)
{memset(flog,0,sizeof(flog));flog[x][y]=true;step[x][y][s]=0;queue<int>q;int pos=x*n+y;q.push(pos);while(!q.empty()){pos=q.front();q.pop();for(int i=0;i<4;i++){int tx=pos/n+dir[i][0];int ty=pos%n+dir[i][1];if(check(tx,ty)){step[tx][ty][s]=step[pos/n][pos%n][s]+1;flog[tx][ty]=true;q.push(tx*n+ty);}}}
}
int main()
{while(scanf("%d%d",&n,&m)!=EOF){//memset(step,0,sizeof(step));for(int i=0;i<n;i++)for(int j=0;j<m;j++)step[i][j][0]=step[i][j][1]=1e5;for(int i=0;i<n;i++)scanf("%s",G[i]);for(int i=0;i<n;i++)for(int j=0;j<m;j++){if(G[i][j]=='Y')BFS(i,j,0);else if(G[i][j]=='M')BFS(i,j,1);}int ans=1e5;for(int i=0;i<n;i++)for(int j=0;j<m;j++)if(G[i][j]=='@'&&ans>step[i][j][0]+step[i][j][1])ans=step[i][j][0]+step[i][j][1];printf("%d\n",ans*11);}return 0;
}



这篇关于hdu 2612 Find a way(BFS)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/730081

相关文章

hdu1254(嵌套bfs,两次bfs)

/*第一次做这种题感觉很有压力,思路还是有点混乱,总是wa,改了好多次才ac的思路:把箱子的移动当做第一层bfs,队列节点要用到当前箱子坐标(x,y),走的次数step,当前人的weizhi(man_x,man_y),要判断人能否将箱子推到某点时要嵌套第二层bfs(人的移动);代码如下:

usaco 1.3 Mixing Milk (结构体排序 qsort) and hdu 2020(sort)

到了这题学会了结构体排序 于是回去修改了 1.2 milking cows 的算法~ 结构体排序核心: 1.结构体定义 struct Milk{int price;int milks;}milk[5000]; 2.自定义的比较函数,若返回值为正,qsort 函数判定a>b ;为负,a<b;为0,a==b; int milkcmp(const void *va,c

poj 3974 and hdu 3068 最长回文串的O(n)解法(Manacher算法)

求一段字符串中的最长回文串。 因为数据量比较大,用原来的O(n^2)会爆。 小白上的O(n^2)解法代码:TLE啦~ #include<stdio.h>#include<string.h>const int Maxn = 1000000;char s[Maxn];int main(){char e[] = {"END"};while(scanf("%s", s) != EO

hdu 2093 考试排名(sscanf)

模拟题。 直接从教程里拉解析。 因为表格里的数据格式不统一。有时候有"()",有时候又没有。而它也不会给我们提示。 这种情况下,就只能它它们统一看作字符串来处理了。现在就请出我们的主角sscanf()! sscanf 语法: #include int sscanf( const char *buffer, const char *format, ... ); 函数sscanf()和

hdu 2602 and poj 3624(01背包)

01背包的模板题。 hdu2602代码: #include<stdio.h>#include<string.h>const int MaxN = 1001;int max(int a, int b){return a > b ? a : b;}int w[MaxN];int v[MaxN];int dp[MaxN];int main(){int T;int N, V;s

hdu 1754 I Hate It(线段树,单点更新,区间最值)

题意是求一个线段中的最大数。 线段树的模板题,试用了一下交大的模板。效率有点略低。 代码: #include <stdio.h>#include <string.h>#define TREE_SIZE (1 << (20))//const int TREE_SIZE = 200000 + 10;int max(int a, int b){return a > b ? a :

hdu 1166 敌兵布阵(树状数组 or 线段树)

题意是求一个线段的和,在线段上可以进行加减的修改。 树状数组的模板题。 代码: #include <stdio.h>#include <string.h>const int maxn = 50000 + 1;int c[maxn];int n;int lowbit(int x){return x & -x;}void add(int x, int num){while

hdu 3790 (单源最短路dijkstra)

题意: 每条边都有长度d 和花费p,给你起点s 终点t,要求输出起点到终点的最短距离及其花费,如果最短距离有多条路线,则输出花费最少的。 解析: 考察对dijkstra的理解。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstrin

hdu 2489 (dfs枚举 + prim)

题意: 对于一棵顶点和边都有权值的树,使用下面的等式来计算Ratio 给定一个n 个顶点的完全图及它所有顶点和边的权值,找到一个该图含有m 个顶点的子图,并且让这个子图的Ratio 值在所有m 个顶点的树中最小。 解析: 因为数据量不大,先用dfs枚举搭配出m个子节点,算出点和,然后套个prim算出边和,每次比较大小即可。 dfs没有写好,A的老泪纵横。 错在把index在d

hdu 1102 uva 10397(最小生成树prim)

hdu 1102: 题意: 给一个邻接矩阵,给一些村庄间已经修的路,问最小生成树。 解析: 把已经修的路的权值改为0,套个prim()。 注意prim 最外层循坏为n-1。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstri